/**
 * 演示程序当前的 “注册/登录” 等操作，是基于 “本地存储” 完成的
 * 当您要参考这个演示程序进行相关 app 的开发时，
 * 请注意将相关方法调整成 “基于服务端Service” 的实现。
 **/
(function($, owner) {
	
	owner.constants = {
	}
	
	owner.aniShow = "pop-in";
	owner.setTapEvent = function(id){
		mui('#' + id).on('tap', 'a', function() {
			var id = this.getAttribute('href');
			var href = this.href;
			var openType = this.getAttribute("open-type");
			console.log("openType = " + openType);
			if (openType == 'common') {
				mui.openWindow({
					id: id,
					url: this.href,
					styles: {
						popGesture: "close"
					},
					show: {
						aniShow: owner.aniShow
					},
					waiting: {
						autoShow: false
					}
				});					
			}
			
		});
	};
	owner.backButtonPress = 0;
//	owner.myBack = function(event) {
//				owner.backButtonPress++;
//				if (owner.backButtonPress > 1) {
//					plus.runtime.quit();
//				} else {
//					plus.nativeUI.toast('再按一次退出应用');
//				}
//				setTimeout(function() {
//					owner.backButtonPress = 0;
//				}, 1000);
//				return false;
//			};


	/**
	 * 用户登录
	 **/
	owner.login = function(params, callback) {
		callback = callback || $.noop;
		params = params || {};
		params.authmobile = params.authmobile || '';
		params.password = params.password || '';
//		params.deviceId = mui.getDeviceId();
	
		var msg = owner.login_check(params);
		if(msg){
			callback(msg);
		}else{
			owner.login_excute(params,callback);
		}
		
//		var users = db.get('$users');
//		var authed = users.some(function(user) {
//			return params.account == user.account && params.password == user.password;
//		});
//		if (authed) {
//			return owner.createState(params.account, callback);
//		} else {
//			return callback('用户名或密码错误');
//		}
	};
	
	owner.login_check = function(params) {
		
		if (params.authmobile.length < 5) {
			return '账号最短为 5 个字符';
		}
		if (params.authmobile.length < 6) {
			return '密码最短为 6 个字符';
		}
		return null;
	}
	 owner.refresh_stack= function(){
	 	mui.action('HBuilder','reload');
	 	mui.action(pages.nav.id,'reload');
	 	mui.action(pages.main.msg.id,'reload');
	 	mui.action(pages.main.contact.id,'reload');
	 	mui.action(pages.main.broadcast.id,'reload');
	 }
	mui.plusReady(function(){
		owner.indexPage = plus.webview.getLaunchWebview();
		
	})
	 owner.refresh_stack_proxy= function(){
	 	if(owner.indexPage){
	 		owner.indexPage.evalJS('app.refresh_stack();');
	 	}
	 }
	//登录
	 owner.login_excute = function(params,callback,isproxy){
	    func_url = rest.LOGIN;
	    console.log(func_url);
	    $.ajax(func_url, {
	        data:JSON.stringify(params),
	        dataType:'json',
	        type:'post',
	        contentType : 'application/json;charset=UTF-8', 
	        timeout:3000,
	        success:function(data){
	        	console.log('login success'+JSON.stringify(data));
	            if(data!=null&&data.uid !=null){
	            	db.set("cookie",data.sessionId);
	            	db.set("deviceId",mui.getDeviceId());
	            	db.set("sessionValidity",data.sessionValidity);
	            	db.set('$user', data);
	            	console.log("icon="+data.icon);
	            	//owner.loadUrlImage(data.icon,function(url){
            			//db.set('icon',url);
	            	//});
	            	db.set('honor',data.honor);
	            	db.set('bday',data.bday);
            		db.set('icon',data.icon);
            		db.set("username",data.username);
            		db.set("password",params.password);
	            	db.set("uid",data.uid);
	            	db.set("authmobile",params.authmobile);
	            	db.set("email",data.email);
	            	db.set("signature",data.signature);
	            	db.set("integral",data.memberData.money);//积分
	            	db.set("topic",data.memberData.postnum);//帖子
	            	db.set("help",data.helpCount);//求助
	            	var skillsArray=[];
	            	var userSkills=data.userSkills;
	            	for(var i=0;i<userSkills.length;i++){
	            		if(userSkills[i].price){
	            			skillsArray.push(userSkills[i].name+":"+userSkills[i].price+"元起价");
	            		}else{
	            			skillsArray.push(userSkills[i].name);
	            		}
	            	}
	            	db.set("userSkills",skillsArray);//技能
	            	
	            	db.set("groupimg",data.userGroups.groupimg);
	            	
	            	db.set("bbs_concern",data.bookmarks||[]);
	            	db.set("contact",data.attentions||[]);
	            	console.log('collections:');
	            	console.log(JSON.stringify(data));
	            	db.set("collections",data.collections||[]);
	            	
					db.set("sex",data.gender);
					console.log('data.messages start');
					if(data.messages){
						console.log(JSON.stringify(data.messages));
					}
					console.log('data.messages end');
					
					data.messages = data.messages||[];
//					data.messages = [
//						{messageid:'10',mtype:'msg',icon:'../images/user/1.jpg',title:'幸福',createddate:'1461813688',content:"哥们在做什么呢？"},
//						{messageid:'8',mtype:'msg',icon:'../images/user/2.jpg',title:'福尔摩斯',createddate:'1461813688',content:"hello！请教一个化学问题"},
//						{messageid:'9',mtype:'msg',icon:'../images/user/nologin.png',title:'马化腾',createddate:'1461813688',content:"我打算转给你10%的股份？"},
//						{messageid:'11',mtype:'post',icon:'',title:'未来计划',createddate:'1461813688',content:'幸福@了你： 我考虑看看'},
//						{messageid:'10',mtype:'post',icon:'',title:'宝宝丢了',createddate:'1461813688',content:'福尔摩斯@了你： 孩子我找到了！'}
//						//{messageid:'',mtype:'like',icon:'',title:'关注提醒',createddate:'1461813688',content:'福尔摩斯关注了你'},
//						//{messageid:'',mtype:'system',icon:'',title:'系统消息',createddate:'1461813688',content:'恭喜您注册成功！欢迎来到XXX'}
//					]
					if(data.messages){
						for(var i=0;i<data.messages.length;i++){
							data.messages[i].date = new Date().timediff(data.messages[i].createddate);
						}
						console.log(JSON.stringify(data.messages));
					}
					var _messages = db.get(db.get("uid")+"_messages");
					if(!_messages){
						
		            	for(var i=0;i<data.messages.length;i++){
							data.messages[i].unread=true;
		            	}
		            	db.set(data.uid+"_messages",data.messages);
		            }else{
		            	for(var i=0;i<data.messages.length;i++){
		            		var inner_length = _messages.length-1;
			            	for(var j=inner_length;j>=0;j--){
			            		if(data.messages[i].mtype == _messages[j].mtype
		            			&& (data.messages[i].messageid == _messages[j].messageid
		            				|| data.messages[i].mtype == 'like' 
		            				|| data.messages[i].mtype == 'system'
		            			)){
			            			_messages.splice(j,1);
			            		}
			            	}
			            	data.messages[i].unread=true;
	            			_messages.unshift(data.messages[i]);
		            	}
		            	db.set(data.uid+"_messages",_messages);
		            }
		            if(!db.get(data.uid+"_messages_topped")){
		            	db.set(data.uid+"_messages_topped",{})
		            }
					console.log('data.messages end');
					
					app.refresh_stack_proxy();
					console.log('refresh_stack');
					//获取默认主页
	            	if(data.defaultForum){
	            		console.log("defaultForum "+JSON.stringify(data.defaultForum));
	            		db.set("defaultForum",data.defaultForum);
	            		db.set("defaultForumfid",data.defaultForum.fid);
	                }
		            if(!isproxy){
		            	$.back();	            	
		            	plus.nativeUI.toast("登陆成功")
		            	if(window.localStorage.bakID){
			            	setTimeout(function(){
								owner.bak();
			            	},100);
		            	}
		            	if(window.localStorage.bakPAGEID){
		            		mui.routerBak();
		            	}
	            	}else{
	            	}
	            	
					console.log('login over');
	            	if(callback){
	            		return callback();
	            	}
	            }else{
	            	if(isproxy){
		            	plus.nativeUI.toast(style.nowifi)
	            	}
	                return callback('用户名或密码错误！');
	            }
	        },
	        error:function(xhr,type,errorThrown){
	        	callback('登陆异常');
	            console.log(type);
	        }
	    });
	};
	
	// 聊天消息提示
	//{messageid:'10',mtype:'msg',icon:'../images/user/1.jpg',title:'幸福',createddate:'1461813688',content:"哥们在做什么呢？"},
	owner.addMessage = function(message) {
		message.date = new Date().timediff(message.time);
		message.mtype = 'msg';
		message.title = '聊天消息';
		message.messageid = message.uid;
		message.icon = '../images/user/nologin.png';
		message.unread = true;		
		
		console.log("本地存储插入一条消息：" + JSON.stringify(message));
		var _messages = db.get(db.get("uid")+"_messages");
		if(!_messages){
			_messages = [];
       	}
		// 先删除本地已有的此人发的消息
		for(var i = 0; i < _messages.length; i++) {
			if (_messages[i].messageid == message.messageid && _messages[i].mtype=='msg' && message.mtype=='msg') {
				console.log("本地已有此人数据,删除之：" + JSON.stringify(_messages[i]));
				_messages.splice(i,1);
			}			
		}

		_messages.unshift(message)
        db.set(db.get("uid")+"_messages",_messages);
	};
	

	
	/**
	 * 新用户注册
	 **/
	owner.reg = function(regInfo, callback) {
		callback = callback || $.noop;
		regInfo = regInfo || {};
		regInfo.username = regInfo.username || '';
		regInfo.password = regInfo.password || '';
		regInfo.authmobile = regInfo.authmobile || '';
//		regInfo.deviceId = mui.getDeviceId();
		if(regInfo.username.length < 1){
			return callback('用户昵称最短需要 1个字符');
		}
		if (regInfo.authmobile.length < 11) {
			return callback('手机号格式不正确');
		}
		if (regInfo.password.length < 6) {
			return callback('密码最短需要 6 个字符');
		}
//		if (!checkEmail(regInfo.email)) {
//			return callback('邮箱地址不合法');
//		}
		console.log(JSON.stringify(regInfo));
		var func_url = rest.REG;
	    mui.ajax(func_url, {
	        data:JSON.stringify(regInfo),
	        dataType:'json',
	        type:'post',
	        contentType : 'application/json;charset=UTF-8', 
	        success:function(data){
	        	
				console.log('reg server pass');
	        	if(data!=null&&data.uid !=null){
	        		
	            	callback();
	            	db.set("deviceId",mui.getDeviceId());
	            	db.set('$user', data);
            		db.set("username",regInfo.username);
            		db.set("password",regInfo.password);
	            	db.set("uid",data.uid);
	            	db.set("authmobile",regInfo.authmobile);
	            	db.set("integral",'0');//积分
	            	db.set("topic",'0');//帖子
	            	db.set("help",'0');//求助
	            	db.set('icon','../images/user/nologin.png');
	            	
	            	db.set("cookie",data.sessionId);
	            	db.set("sessionValidity",data.sessionValidity);
	            	app.refresh_stack_proxy();
	            	mui.toast("恭喜！注册成功");
	            	owner.login(regInfo, callback);
	            	plus.webview.getWebviewById("login").evalJS("mui.back()");
	            	if(window.localStorage.bakID){
		            	setTimeout(function(){
							owner.bak();
		            	},100);
	            	}
	            	if(window.localStorage.bakPAGEID){
	            		mui.routerBak();
	            	}
	            }else{
	                return callback(data.msg);
	            }
	        },
	        error:function(xhr,type,errorThrown){
	           console.log(type);
	        }
	    });
	};
	owner.loadUrlImage =function(url,callback){
		console.log("loginURL="+url);
		if(url && url!=''){
			console.log("url");
		    var img = new Image();
			img.src = url;
			var base64;
			img.onload = function(){
				console.log("PNG");
				var canvas=document.createElement('canvas');
				canvas.width=img.width;
				canvas.height=img.height;
				var ctx = canvas.getContext('2d');
				ctx.drawImage(img,img.width,img.height);
				base64 = canvas.toDataURL('image/'+url.split(".")[1],1||0.8);
				console.log("base64="+base64);
				callback(url);
			}
		}else{
			console.log("base64");
			callback('../images/user/nologin.png');
		}
	}
	owner.createState = function(name, callback) {
		var state = owner.getState();
		state.account = name;
		state.token = "token123456789";
		owner.setState(state);
		return callback();
	};
	owner.openWindow = function(page){
		if(page.auth && db.get("cookie") == null){
			
	        mui.plusReady(function(){
	        	window.localStorage.bakPAGEID=plus.webview.currentWebview().id;
	        });
    		mui.bakPAGE = {
    			type:"common",
    			page:page
    		}
			mui.openWindow(pages.sub.login);
		}else{
			mui.openWindow(page);
		}
	}
	/**
	 * 请求返回登录的状态
	 */
	owner.getLoginState = function(data){
		var loginExpire = data.loginExpire;
		if(loginExpire!=undefined&&loginExpire){
//			var btn = ["确定","取消"];
//		    mui.confirm('是否打开登录?','App',btn,function(e){
//			    if(e.index==1){
//			    	$.back();
//			    }else{
			    	mui.openWindow(pages.sub.login);
//			    }
//		    });
		   return false;
		}else{
			return true;
		}
	}
	/**
	 * 获取是否登录状态
	 */
	owner.isLogin = function(){
        var cookie = localStorage.getItem("cookie");
		if(cookie == null){
			mui.openWindow(pages.sub.login);
			return false;
		}
		return true;
	}
	/**
	 * 获取当前状态
	 **/
	owner.getState = function() {
		var stateText = localStorage.getItem('$state') || "{}";
		return JSON.parse(stateText);
	};

	/**
	 * 设置当前状态
	 **/
	owner.setState = function(state) {
		state = state || {};
		db.set('$state', state);
		//var settings = owner.getSettings();
		//settings.gestures = '';
		//owner.setSettings(settings);
	};

	var checkEmail = function(email) {
		email = email || '';
		return (email.length > 3 && email.indexOf('@') > -1);
	};

	/**
	 * 找回密码
	 **/
	owner.forgetPassword = function(email, callback) {
		callback = callback || $.noop;
		if (!checkEmail(email)) {
			return callback('邮箱地址不合法');
		}
		return callback(null, '新的随机密码已经发送到您的邮箱，请查收邮件。');
	};

	/**
	 * 获取应用本地配置
	 **/
	owner.setSettings = function(settings) {
		settings = settings || {};
		db.set('$settings', settings);
	}

	/**
	 * 设置应用本地配置
	 **/
	owner.getSettings = function() {
		return db.get('$settings') || {};
	}
	/**
	 * params：json格式
	 * url
	 * type: get||post
	 * successfn 成功回调函数
	 * errorfn 失败回调函数
	 **/
	owner.bakXHR =null;
	owner._bak = function(){
		if(owner.bakXHR){
			var temp = owner.bakXHR;
			owner.bakXHR = null;
			window.localStorage.bakID = null;
			owner.ajax(temp.url,temp.setting);
		}
	}
	owner.bak = function(){
		if(window.localStorage.bakID){
			plus.webview.getWebviewById(window.localStorage.bakID).evalJS("app._bak()");
		}
	}
	owner.get = function(url,data,successfn,errorfn,before,isReload){
		mui.plusReady(function(){
			if (plus.networkinfo.getCurrentType() == plus.networkinfo.CONNECTION_NONE){
		    		mui.toast(style.nowifi);
		    		return;
		    }
		});
		var setting={
		 	headers:{'deviceId':db.get('deviceId'),"Cookie":"JSESSIONID="+db.get("cookie"),"isLogin":true,"authmobile":db.get('authmobile'),"password":db.get('password')},
            data:JSON.stringify(data),
	        dataType:'json',
	        type:'get',
	        contentType : 'application/json;charset=UTF-8', 
	        timeout:10000,
            success: function(d){
            	if(d&&d.sessionValidity){
					console.log("sessionValidity:"+d.sessionValidity);
	            	db.set("sessionValidity",d.sessionValidity);
	            }
            	if(before){
            		before();
            	}
            	var loginState = owner.getLoginState(d);
            	if(loginState){
            		if(successfn){
            			successfn(d);
	            	}
            	}else{
            		if(errorfn){
	                	errorfn(null,'nologin',null);
	            	}
            	}
            },
            error: function(xhr,type,errorThrown){
            	if(before){
            		before();
            	}
            	if(errorfn){
                	errorfn(xhr,type,errorThrown);
            	}
            }
        };
        
        if(isReload){
	        mui.plusReady(function(){
	        	window.localStorage.bakID=plus.webview.currentWebview().id;
	        });
    		owner.bakXHR = {
    			url:url,
    			setting:setting
    		}
        }
		$.ajax(url,setting);
	}
	
	owner.post = function(url,data,successfn,errorfn,before,isReload){
		mui.plusReady(function(){
			if (plus.networkinfo.getCurrentType() == plus.networkinfo.CONNECTION_NONE){
		    		mui.toast(style.nowifi);
		    		return;
		    }
		});
		var setting={
		 	headers:{'deviceId':db.get('deviceId'),"Cookie":"JSESSIONID="+db.get("cookie"),"isLogin":true,"authmobile":db.get('authmobile'),"password":db.get('password')},
            data:JSON.stringify(data),
	        dataType:'json',
	        type:'post',
	        contentType : 'application/json;charset=UTF-8', 
	        timeout:10000,
            success: function(d){
            	if(d&&d.sessionValidity){
					console.log("sessionValidity:"+d.sessionValidity);
	            	db.set("sessionValidity",d.sessionValidity);
	            }
            	if(before){
            		before();
            	}
            	var loginState = owner.getLoginState(d);
            	if(loginState){
            		successfn(d);
            	}else{
            		if(errorfn){
	                	errorfn(null,'nologin',null);
	            	}
            	}
            },
            error: function(xhr,type,errorThrown){
            	if(before){
            		before();
            	}
            	if(errorfn){
                	errorfn(xhr,type,errorThrown);
            	}
            }
        };
        
        if(isReload){
	        mui.plusReady(function(){
	        	window.localStorage.bakID=plus.webview.currentWebview().id;
	        });
    		owner.bakXHR = {
    			url:url,
    			setting:setting
    		}
        }
		$.ajax(url,setting);
	}
	/**
	 * params：json格式
	 * url
	 * type: get||post
	 * successfn 成功回调函数
	 * errorfn 失败回调函数
	 **/
	owner.ajax = function(url,setting){
		mui.plusReady(function(){
			if (plus.networkinfo.getCurrentType() == plus.networkinfo.CONNECTION_NONE){
		    		mui.toast(style.nowifi);
		    		return;
		    }
		});
        if(setting.isReload){
        	setting.isReload = false;
	        mui.plusReady(function(){
	        	window.localStorage.bakID=plus.webview.currentWebview().id;
	        });
    		owner.bakXHR = {
    			url:url,
    			setting:setting
    		}
        }
		setting.headers = {'deviceId':db.get('deviceId'),"Cookie":"JSESSIONID="+db.get("cookie"),"isLogin":true,"authmobile":db.get('authmobile'),"password":db.get('password')};
		var callback = setting.success;
		setting.success = function(d){
			if(d&&d.sessionValidity){
					console.log("sessionValidity:"+d.sessionValidity);
	            	db.set("sessionValidity",d.sessionValidity);
	        }
			if(setting.before){
				setting.before(d);
			}
			if(owner.getLoginState(d)){
				callback(d);
			}else{
				mui.toast('请先登录');
			}
			if(setting.after){
				setting.after(d);
			}
			
		}
		$.ajax(url,setting);
	}
	
	owner.report = function(tid,pid,uid){
				
		var btnArray = [{
			title: "色情低俗"
		}, {
			title: "广告滥用"
		}, {
			title: "政治敏感"
		}, {
			title: "散布谣言"
		}, {
			title: "诈欺/售假"
		}, {
			title: "暴力/违法"
		}, {
			title: "其它（需要填写）"
		}];
		plus.nativeUI.actionSheet({
			title: "投诉",
			cancel: "取消",
			buttons: btnArray
		}, function(e) {
			var index = e.index;
			var pre_src="";
			
			//
			
			switch (index) {
				case 0: 
					break;
				case 1:
					plus.nativeUI.alert("您的反馈已提交，我们会据情节轻重采取措施");
					break;
				case 2:
					plus.nativeUI.alert("您的反馈已提交，我们会据情节轻重采取措施");
					break;
				case 3:
					plus.nativeUI.alert("您的反馈已提交，我们会据情节轻重采取措施");
					break;
				case 4:
					plus.nativeUI.alert("您的反馈已提交，我们会据情节轻重采取措施");
					break;
				case 5:
					plus.nativeUI.alert("您的反馈已提交，我们会据情节轻重采取措施");
					break;
				case 6:
					plus.nativeUI.alert("您的反馈已提交，我们会据情节轻重采取措施");
					break;
				case 7:
					mui.router('common',pages.sub.bbs_editor_req,{page_type:'inform',tid:tid,
						pid:pid,
						uid:uid});
					break;
				}
				if(index>0 && index <7){
					var data = {
						tid:tid,
						pid:pid,
						uid:uid,
						reason:btnArray[index-1].title,
						type:'object'
					};
					owner.post(rest.REPORT,data,
						function(d){
						},
						function(){
							mui.toast(style.nowifi);
						}
					);
				}
		});
	}
	owner.getLevel = function(postNum){
		var groupimg;//等级值
		var grouptitle;//等级名称
		var exp;//经验
		if(postNum<=1){
			groupimg=1,
			grouptitle='新手上路',
			exp = 0;
		}
		else if(postNum>1&&postNum<=100){
			groupimg=2,
			grouptitle='侠客',
			exp = postNum;
		}else if(postNum>100&&postNum<=300){
			groupimg=3,
			grouptitle='骑士',
			exp = (postNum-100)/200;
		}else if(postNum>300&&postNum<=600){
			groupimg=4,
			grouptitle='圣骑士',
			exp = (postNum-300)/300;
		}else if(postNum>600&&postNum<=1000){
			groupimg=5,
			grouptitle='精灵王';
		}else if(postNum>1000&&postNum<=5000){
			groupimg=6,
			grouptitle='风云使者',
			exp = (postNum-1000)/4000;
		}else if(postNum>5000&&postNum<=10000){
			groupimg=7,
			grouptitle='光明使者',
			exp = (postNum-5000)/5000;
		}else if(postNum>10000&&postNum<=50000){
			groupimg=8,
			grouptitle='天使',
			exp = (postNum-10000)/40000;
		}
		var ownerLevelInfo={groupimg:groupimg,grouptitle:grouptitle,exp:exp};
		return ownerLevelInfo;
	}
	//计算距离
	var EARTH_RADIUS = 6378137.0;    //单位M 
    owner.getGreatCircleDistance=function(lat1,lng1,lat2,lng2){  
        var radLat1 = getRad(lat1);  
        var radLat2 = getRad(lat2);  
          
        var a = radLat1 - radLat2;  
        var b = getRad(lng1) - getRad(lng2);  
          
        var s = 2*Math.asin(Math.sqrt(Math.pow(Math.sin(a/2),2) + Math.cos(radLat1)*Math.cos(radLat2)*Math.pow(Math.sin(b/2),2)));  
        s = s*EARTH_RADIUS;  
        s = Math.round(s);  
                  
        return s;  
    };
    function getRad(d){  
        return d*Math.PI/180.0;  
    };
	//显示qq表情
	 owner.qqFaceShow=function(content){
		var arr=content.match(/([^\[\]]+)(?=\.g])/g);
		var img;
		var html;
		var id;
		if(arr){
			for(var i=0;i<arr.length;i++){
				id=arr[i].replace('em_','');
				img = id+".gif";
				html="<img src='../images/arclist/"+img+"'>";
				console.log("html="+html);
				content=content.replace("[em_"+id+".g]",html);
			}
		}
		return content;
	}
	 //获取位置
	 owner.ISopenGPS=function(successfn,errorfn){
	 	if (mui.os.android){
			    var context = plus.android.importClass("android.content.Context");
	            var locationManager=plus.android.importClass("android.location.LocationManager");
	            var main=plus.android.runtimeMainActivity();
	            var mainSvr=main.getSystemService(context.LOCATION_SERVICE);
	            var status=mainSvr.isProviderEnabled(locationManager.GPS_PROVIDER);
	            console.log("status=" + status);
	            if(!status){
			    	mui.confirm('定位服务未开启，请在设置中开启定位服务。', '温馨提示', ['取消', '开启定位'], function(e){
			    		 if(e.index == 0){
			    		 }else{
			    		 	var main = plus.android.runtimeMainActivity();
                            var Intent = plus.android.importClass("android.content.Intent");
                            var locationManager=plus.android.importClass("android.location.LocationManager");
                            var mIntent = new Intent('android.settings.LOCATION_SOURCE_SETTINGS');
                            main.startActivity(mIntent);
			    		 }
			    	});
		    	}
		    	owner.handlerOpenGPS(successfn,errorfn);
		}else{
			owner.handlerOpenGPS(successfn,errorfn);
		}
	 }
	 owner.handlerOpenGPS=function(successfn,errorfn){
	 	var iscalled = false;
			console.log("in handlerOpenGPS");
				setTimeout(function(){
					var cache_gps = db.get('cache_gps');
					if(cache_gps && !iscalled){
						successfn(cache_gps);
					}
				},1000)
				 plus.geolocation.getCurrentPosition(function(position){
		 			iscalled = true;
					console.log("position="+JSON.stringify(position));
	                var d={position:position,process:""};
	                db.set('cache_gps',d);
					successfn(d);
				  }, function(e) {
		 			iscalled = true;
					console.log("获取百度定位位置信息失败：" + e.message);
	                var d={position:db.get("baidu_position"),process:"end"};
					errorfn(d);
					if(mui.os.ios){
						mui.confirm('定位服务未开启，请在设置中开启定位服务。', '温馨提示', ['取消', '开启定位'], function(e){
	                        if(e.index == 0){
	                        } else {
	                            plus.runtime.launchApplication({action: 'prefs:root=LOCATION_SERVICES'}, function(e){}); //WIFI
	                        }
	                    });
	               }
				}, {
					provider: 'baidu'
				});
				
		}
	
}(mui, window.app = {}));