  
(function (){
	
	Date.prototype.timediff=function(ts){
		var _date_ts = new Date(parseInt(ts)*1000);
		var td = this.getTime() - parseInt(ts)*1000;
		if(td<(60*1000)){
			return "刚刚"
		}else if(td<(60*60*1000)){
			return Math.floor(td/(1000*60))+"分钟以前";
		}else if(td<(24*60*60*1000)){
			return Math.floor(td/(1000*60*60))+"小时以前";
		}else if(Math.floor(td/(1000*60*60*24))<2 && this.getDate() -1== _date_ts.getDate()){
			return "昨天"
		}else if(Math.floor(td/(1000*60*60*24))<3 && this.getDate() -2== _date_ts.getDate()){
			return "前天"
		}else if(this.getYear() == _date_ts.getYear()){
			return _date_ts.getMonth()+1+"月"+_date_ts.getDate()+"日";
		}else{
			return _date_ts.getYear()+"年";
		} 
	}
	Date.prototype.pattern=function(fmt) {  
    var o = {         
    "M+" : this.getMonth()+1, //月份         
    "d+" : this.getDate(), //日         
    "h+" : this.getHours()%12 == 0 ? 12 : this.getHours()%12, //小时         
    "H+" : this.getHours(), //小时         
    "m+" : this.getMinutes(), //分         
    "s+" : this.getSeconds(), //秒         
    "q+" : Math.floor((this.getMonth()+3)/3), //季度         
    "S" : this.getMilliseconds() //毫秒         
    };         
    var week = {         
    "0" : "/u65e5",         
    "1" : "/u4e00",         
    "2" : "/u4e8c",         
    "3" : "/u4e09",         
    "4" : "/u56db",         
    "5" : "/u4e94",         
    "6" : "/u516d"        
    };         
    if(/(y+)/.test(fmt)){         
        fmt=fmt.replace(RegExp.$1, (this.getFullYear()+"").substr(4 - RegExp.$1.length));         
    }         
    if(/(E+)/.test(fmt)){         
        fmt=fmt.replace(RegExp.$1, ((RegExp.$1.length>1) ? (RegExp.$1.length>2 ? "/u661f/u671f" : "/u5468") : "")+week[this.getDay()+""]);         
    }         
    for(var k in o){         
        if(new RegExp("("+ k +")").test(fmt)){         
            fmt = fmt.replace(RegExp.$1, (RegExp.$1.length==1) ? (o[k]) : (("00"+ o[k]).substr((""+ o[k]).length)));         
        }         
    }         
    return fmt;         
}    

//阶段string，尾部加'...'
String.prototype.truncate = function(num) {
	if(this.length < num)
		return this;
	return this.substr(0,num) + '...';
}
	mui.fn.remove = function(){
		for(var i=0;i<this.length;i++){
			if(this[i] && this[i].parentNode){
				this[i].parentNode.removeChild(this[i]);
			}
		}
	}
	mui.fn.parent = function(){
		var rtn = this[0];
			rtn = rtn.parentNode;
		return mui(rtn);
	}
	mui.fn.find = function(sel){
		return mui(this[0].querySelector(sel));
	}
	mui.fn.findAll = function(sel){
		return mui(this[0].querySelectorAll(sel));
	}
	mui.fn.onTap = function(func){
		
		for(var i=0;i<this.length;i++){
			var item =this[i];
			item.addEventListener('tap',function(){
				func(item);
			});
		}
	}
	
	mui.scrollTop = function(_time){
		var time =_time?_time:100;
		mui('#pullrefresh').pullRefresh().scrollTo(0,0,time);
		/*var scrolls = mui('.mui-scroll');
		for(var i=0;i<scrolls.length;i++){
			scrolls[i].style.transform="";
		}*/
		mui.scrollTo(0, time);
	}
	mui.fn.parents = function(index){
		var rtn = this[0];
		for(var i=index;i>0;i--){
			rtn = rtn.parentNode;
		}
		return mui(rtn);
	}
	mui.fn.show = function(layout){
		for(var i=0;i<this.length;i++){
			this[i].style.display=layout?layout:"block";
		}
		return this;
	}
	mui.fn.hide = function(){
		for(var i=0;i<this.length;i++){
			this[i].style.display="none";
		}
		return this;
	}
	
	mui.fn.in = function(pos){
		this[0].style.top=pos.top;
		this[0].style.bottom=pos.bottom;
		return this;
	}
	mui.fn.out = function(v){
		
		this[0].style.top="-100%";
		this[0].style.bottom="auto";
		return this;
	}
	mui.fn.addClass = function(className){
		for(var i=0;i<this.length;i++){
			if(this[i].className ){
				if(!this[i].classList.contains(className)){
					this[i].classList.add(className);
				}
			}else{
				this[i].className = className;
			}
		}
	}
	mui.dot = function(text1,size){
		if(!text1){
			return "";
		}
		if(!size){
			size = 12;
		}
		if(text1.length>size){
			return text1.substring(0,size)+"...";
		}else{
			return text1;
		}
	}
	mui.fn.removeClass = function(className){
		for(var i=0;i<this.length;i++){
			if(this[i].className && this[i].classList.contains(className) ){
				this[i].classList.remove(className);

			}
		}
	}
	mui.loadView = function(options,isPre) {
		var isfind=false;
		var refresh_view;
		var parent_view;
		if (mui.os.plus ) {
			mui.plusReady(function() {
				refresh_view = plus.webview.getWebviewById(options.id);
				parent_view = plus.webview.currentWebview();
				//如果存在重新打开，不存在则创建
				if(refresh_view){
					mui.fire(refresh_view,'refresh');
					isfind = true;
					refresh_view.show();
				}else{
					
						//这里需要判断一下，最好等子窗口加载完毕后，再调用主窗口的show方法；
						//或者：在openwindow方法中，监听实现；
						var appendwv= mui.appendWebview(options);
						if(appendwv){
							if(options.preindex==1){
								appendwv.show();
							}else{
									
								appendwv.hide();
							}
						}
						//if(isPre&&!options.default){
						//	refresh_view.hide();
						//}
						//判断是否首页
						if (parent_view === plus.webview.getWebviewById(plus.runtime.appid)) {
							mui.isHomePage = true;
							//首页需要自己激活预加载；
							//timeout因为子页面loaded之后才append的，防止子页面尚未append、从而导致其preload未触发的问题；
							setTimeout(function() {
								triggerPreload(parent_view);
							}, 300);
						}
						//设置ios顶部状态栏颜色；
						if (mui.os.ios && options.statusBarBackground) {
							plus.navigator.setStatusBarBackground(options.statusBarBackground);
						}
						if (mui.os.ios && options.statusBarStyle) {
							plus.navigator.setStatusBarStyle(options.statusBarStyle);
						}
						
						
						if (mui.os.android && parseFloat(mui.os.version) < 4.4) {
							//解决Android平台4.4版本以下，resume后，父窗体标题延迟渲染的问题；
							if (parent_view.parent() == null) {
								document.addEventListener("resume", function() {
									var body = document.body;
									body.style.display = 'none';
									setTimeout(function() {
										body.style.display = '';
									}, 10);
								});
							}
						}
				}
				
				var childViews = parent_view.children();
				for(var i=0;i<childViews.length;i++){
					if(!refresh_view || refresh_view!==childViews[i]){
						if(!isPre){
							childViews[i].hide();
						}
					}
				}
			});
		}else{
			
			var iframes = mui("iframe.sub"),dest_iframe;
			var wrappers = mui(".mui-iframe-wrapper"),dest_wrapper;
			
			for(var i=0;i<iframes.length;i++){
				var temp_iframe = iframes[i];
				var temp_wrapper = temp_iframe.parentNode;
				if(options.id == iframes[i].id){
					dest_iframe = iframes[i]
					dest_wrapper = temp_iframe.parentNode;
					temp_wrapper.style.display="block";
					temp_iframe.style.display="block";
					temp_wrapper.style.zIndex=temp_wrapper.style.zIndexBak;
					isfind = true;
				}else{
					if(!temp_iframe.classList.contains("cache")){
						temp_wrapper.innerHTML="";
						mui(temp_wrapper).remove();
						
					}else{
						temp_wrapper.style.display="none";
						temp_iframe.style.display="none";
						if(temp_wrapper.style.zIndex){
							temp_wrapper.style.zIndexBak = temp_wrapper.style.zIndex;
							temp_wrapper.style.zIndex = "-1";
						}
					}
				}
			}
			
			if(!isfind) {
						var wrapper = document.createElement('div');
						wrapper.className = 'mui-iframe-wrapper';
						var styles = options.styles || {};
						if (typeof styles.top !== 'string') {
							styles.top = '0px';
						}
						if (typeof styles.bottom !== 'string') {
							styles.bottom = '0px';
						}
						wrapper.style.top = styles.top;
						wrapper.style.bottom = styles.bottom;
						wrapper.style.zIndex = styles.zIndex;
						var iframe = document.createElement('iframe');
						iframe.src = options.url;
						iframe.id = options.id || options.url;
						iframe.name = iframe.id;
						iframe.className ="sub";
						if(options.cache == null || options.cache == true){
							iframe.classList.add("cache");
						}
						wrapper.id =options.id+"-wrapper";
						wrapper.appendChild(iframe);
						if(options.parentNode){
							document.querySelector(options.parentNode).appendChild(wrapper);
						}else{
							document.getElementsByTagName('body')[0].appendChild(wrapper);
						}
						//目前仅处理微信
						mui.os.wechat && handleScroll(wrapper, iframe);
					}
		}
		mui.plusReady(function(){
			
		});
		function triggerPreload (webview) {
			if (!webview.preloaded) {
				mui.fire(webview, 'preload');
				var list = webview.children();
				for (var i = 0; i < list.length; i++) {
					mui.fire(list[i], 'preload');
				}
				webview.preloaded = true;
			}
		};
		function handleScroll(wrapper, iframe) {
			var key = 'MUI_SCROLL_POSITION_' + document.location.href + '_' + iframe.src;
			var scrollTop = (parseFloat(localStorage.getItem(key)) || 0);
			if (scrollTop) {
				(function(y) {
					iframe.onload = function() {
						window.scrollTo(0, y);
					};
				})(scrollTop);
			}
			setInterval(function() {
				var _scrollTop = window.scrollY;
				if (scrollTop !== _scrollTop) {
					localStorage.setItem(key, _scrollTop + '');
					scrollTop = _scrollTop;
				}
			}, 100);
		};
	};

	mui.bakPAGE =null;
	mui.router_bak = function(){
		if(mui.bakPAGE){
			var temp = mui.bakPAGE;
			console.log(JSON.stringify(temp));
			mui.bakPAGE = null;
			window.localStorage.bakPAGEID = null;
			mui.router(temp.type,temp.page);
		}
	}
	mui.routerBak = function(){
		if(window.localStorage.bakPAGEID){
			plus.webview.getWebviewById(window.localStorage.bakPAGEID).evalJS("mui.router_bak()");
		}
	}
	mui.router = function(type,page,params,isNocheck){
		if(params){
			page.extras = params;
		}
		
		
	  var _page = page;
		if (type == "common" && page.only !=true) {
			_page.id +=(""+ Math.ceil( Math.random()*10000));
		}
		//登陆了并且没超时
		if(mui.isLogined()){
			//alert('登陆了并且没超时');
			if(type=="sub"){
				mui.loadView(_page);
				
			}else if (type == "common") {
				mui.openWindow(_page);
			}
			
		}else{
		//没登
			//if(db.get('password')==null){
				
				//没登,但属于可通行页面
				if(mui.isPassable(_page)){
					//alert('没登,但属于可通行页面');
					if(type=="sub"){
						mui.loadView(_page);
						
					}else if (type == "common") {
						mui.openWindow(_page);
					}
				//没登,但该页面必须登
				}else{
					if(isNocheck){
						//alert('预加载不强制登录');
						//预加载不强制登录
						if(type=="sub"){
							mui.loadView(_page);
						}
					}else{
						//alert('没登,但该页面必须登');
				        mui.plusReady(function(){
				        	window.localStorage.bakPAGEID=plus.webview.currentWebview().id;
				        });
			    		mui.bakPAGE = {
			    			type:type,
			    			page:_page
			    		}
						mui.openWindow(pages.sub.login);
					}
				}
		//登陆过了 超时了，连接一下回来继续干活
			//}
//			else{
//				
//						var geTuiClientinfo = plus.push.getClientInfo();
//						var geTuiClientId = geTuiClientinfo ? geTuiClientinfo.clientid : "";
//						console.log("Getui info:" + geTuiClientinfo.clientid);
////						alert(geTuiClientinfo.clientid);
//						var loginInfo = {
//							authmobile: accountBox.value,
//							password: passwordBox.value,
//							memberContactInfo : {getuiClientId : geTuiClientId} // 个推client id
//						};
//				//alert('登陆过了 超时了，连接一下回来继续干活');
//				app.login_excute({authmobile:db.get('authmobile'),password:db.get('password')},function(err){
//			 			if(type=="sub"){
//							mui.loadView(page);
//							
//						}else if (type == "common") {
//							mui.openWindow(page);
//						}
//			  },true);
//			}
		}

	}
	mui.isPassable = function(page){
		
		//var localStorage.getItem("sessionValidity");
		return (page.auth && (db.get('deviceId') != null)) || !page.auth;
	}
	mui.fn.isBlank = function(){
		if(!this[0]){
			return true;
		}
		if(this[0].value.replace(/\d/g,'') == ''){
			return true;
		}
		return false;
	}
	mui.fn._destroy = function(){
		var id = this[0].id;
		for(var key in mui.data){
			var obj = mui.data[key];
			if(obj.element != null&&obj.element.id==id){
				obj.destroy();
			}
		}
	}
	mui.isLogined = function(){
		return db.get("deviceId") != null
	}
	mui.fn.onEvent = function (event_name, selector, callback){

		if(selector){
			var __ary = this[0].querySelectorAll(selector);
			for(var i=0;i<__ary.length;i++){
				//btn.removeEventListener("click", handler, false);  //有效！
//				__ary[i].removeEventListener(event_name,callback);
				if(__ary[i].getAttribute('hasEvent') !='true'){
					__ary[i].setAttribute('hasEvent','true');
					__ary[i].addEventListener(event_name,callback);
				}
			}
		}else{
//			this[0].removeEventListener(event_name,callback);
			this[0].addEventListener(event_name,callback);
		}
	}
	mui.routerSetting = function(pid,ctag,event_name,pages,callback){
		if(mui(pid).length == 0){
			return;
		}
		var obj = pid;
		
		if(typeof(pid) == "string" ){
			obj = mui(pid);
			
		}
		
		if(ctag == null){
			for(var i=0;i<obj.length;i++){
				obj[i].addEventListener(event_name,function(){
					var id = this.getAttribute('href');
					if(!id || !pages[id]){
						return;
					}
					var href = pages[id].url;
					var type = this.getAttribute("open-type");
					
					var params = this.getAttribute('params');
					if(params!=null && params!=""){
						params = JSON.parse(params);
					}else{
						params=null;
					}
					mui.router(type,pages[id],params);
				});
			}
			return;
		}
		if(typeof(pid) == "string" ){
			var objs = mui(pid+" "+ctag);
			for(var i=objs.length-1;i>=0;i--){
				var oid = objs[i].getAttribute('href');
				var otype = objs[i].getAttribute('open-type');
				if(otype == 'sub' && pages[oid]&& pages[oid].preload){
					mui.router('sub',pages[oid],null,true);
				}
			}
		}
		obj.onEvent(event_name, ctag, function(){
				
					var id = this.getAttribute('href');
					if(!id || !pages[id]){
						return;
					}
					var href = pages[id].url;
					var type = this.getAttribute("open-type");
					var params = this.getAttribute('params');
					if(params!=null && params!=""){
						params = JSON.parse(params);
					}else{
						params=null;
					}
					mui.router(type,pages[id],params);
					
					if(callback){
						callback(this,mui.isPassable(pages[id]));
					}
			},true);	
	}
	
	mui.actionByOpener = function(eventname){
		mui.plusReady(function() {
			if(!mui.opener){
				mui.opener = plus.webview.currentWebview().opener();
			}
			if(mui.opener){
				mui.fire(mui.opener,eventname||'refresh');
				return;
			}
		});
	};
	mui.actionByOpenerSub = function(eventname){
		mui.plusReady(function() {
			if(!mui.openerSub){
				mui.openerSub = plus.webview.currentWebview().opener().children()[0];
				if(!mui.openerSub){
					mui.openerSub = plus.webview.currentWebview().opener();
				}
			}
			if(mui.openerSub){
				mui.fire(mui.openerSub,eventname||'refresh');
				return;
			}
		});
	};
	mui.actionByParent = function(eventname){
		mui.plusReady(function() {
			if(!mui.parent){
				mui.parent = plus.webview.currentWebview().parent();
			}
			if(mui.parent){
				mui.fire(mui.parent,eventname||'refresh');
				return;
			}
		});
	};
	mui.actionBySub = function(eventname){
		mui.plusReady(function() {
			if(!mui.subpage){
				mui.subpage = plus.webview.currentWebview().children()[0];
			}
			if(mui.subpage){
				mui.fire(mui.subpage,eventname||'refresh');
				return;
			}
		});
	};
	mui.action = function(pageid,eventname){
		mui.plusReady(function() {
			//alert(pageid+'-'+eventname);
			var webview;
			//alert(plus);
			if(pageid == 'HBuilder'){
				webview = plus.webview.getLaunchWebview();
			}else{
				webview = plus.webview.getWebviewById(pageid);
			}
			if(webview){
				//alert('Page finded:'+pageid);
				mui.fire(webview,eventname||'refresh');
				return;
			}
			//alert('Page not finded:'+pageid);
		});
	}
	mui.getDeviceId =function(){
		var deviceId;
		if(db.get('deviceId')){
			deviceId = db.get('deviceId');
		}else if(plus){
			deviceId = plus.device.uuid;
		}
		return deviceId;
	}
	mui.getClientId =function(){
		var geTuiClientId;
		if(plus){
			var geTuiClientinfo = plus.push.getClientInfo();
			geTuiClientId = geTuiClientinfo ? geTuiClientinfo.clientid : null;
		}
		
		return geTuiClientId;
	}
	mui.fn.loading = function(TYPE){
		if(this[0].tagName.toLowerCase()=='img'){
			if(TYPE=='close'){
				var loaded = this[0].parentNode.querySelector('.mui-spinner-block');
				this[0].classList.remove('css-blur');
				if(loaded){
					mui(loaded).remove();
				}
				
			}else{
				this[0].classList.add('css-blur');
				var span = document.createElement('span');
				span.className = "mui-spinner mui-spinner-block";
				span.style.zIndex = '2000';
				span.style.width="30px";
				span.style.height="30px";
				span.style.marginTop = "-"+Math.ceil(this[0].height/2+10)+"px";
				span.style.marginLeft = "-10px";
				this[0].parentNode.appendChild(span);
			}
		}else if(this[0].classList.contains('mui-icon')){
			
			if(TYPE=='close'){
				var loaded = this[0].querySelector('.mui-spinner-block');
				if(loaded){
					mui(loaded).remove();
				}
				this[0].style.fontSize=this[0].getAttribute('fontSize');
			}else{
				this[0].setAttribute('fontSize',this[0].style.fontSize);
				this[0].style.fontSize='0pt';
				this[0].innerHTML ='<span class="mui-spinner mui-spinner-block" ></span>'+this[0].innerHTML;
			}
		}else{
			if(TYPE=='close'){
				var loaded = this[0].querySelector('.mui-spinner-block');
				if(loaded){
					mui(loaded).remove();
				}
				
			}else{
				this[0].innerHTML ='<span class="mui-spinner mui-spinner-block" ></span>'+this[0].innerHTML;
			}
		}
		//this[0].insertBefore()
	}
	mui.fn.share = function(icon_src){
		
		//分享操作
		var shares = {};
		
		mui.plusReady(function() {
			plus.share.getServices(function(s) {
				if (s && s.length > 0) {
					for (var i = 0; i < s.length; i++) {
						var t = s[i];
						shares[t.id] = t;
					}
				}
			}, function() {
				console.log("获取分享服务列表失败");
			});
		});
		//分享链接点击事件
		;
		var ids = [
			{
				id: "weixin",
				ex: "WXSceneSession"
			}, 
			{
				id: "weixin",
				ex: "WXSceneTimeline"
			}, 
			{
				id: "sinaweibo"
			}, 
			{
				id: "tencentweibo"
			}, 
			{
				id: "qq"
			}
		],
		bts = [
			{
				title: "发送给微信好友"
			}, {
				title: "分享到微信朋友圈"
			}
		];
		for(var i = 0;i<this.length;i++){
			this[i].addEventListener('tap', function() {
				var share_href = this.getAttribute("href");
				var share_title = this.getAttribute("title");
				var share_content = this.getAttribute("content");
				plus.nativeUI.actionSheet({
					cancel: "取消",
					buttons: bts
				}, function(e) {
					var i = e.index;
					if (i > 0) {
						var s_id = ids[i - 1].id;
						var share = shares[s_id];
						if (share) {
							if (share.authenticated) {
								shareMessage(share, ids[i - 1].ex,share_href,share_title,share_content,icon_src);
							} else {
								share.authorize(function() {
									shareMessage(share, ids[i - 1].ex,share_href,share_title,share_content,icon_src);
								}, function(e) {
									console.log("认证授权失败：" + e.code + " - " + e.message);
								});
							}
						} else {
							mui.toast("无法获取分享服务，请检查manifest.json中分享插件参数配置，并重新打包")
						}
					}
				});
			});
		}

		function shareMessage(share, ex,share_href,share_title,share_content,icon_src) {
			var msg = {
				extra: {
					scene: ex
				}
			};
			msg.href = share_href;//"http://www.dcloud.io/hellomui/";
			msg.title = share_title;//"最接近原生APP体验的高性能前端框架";
			msg.content = share_content;//"我正在体验HelloMUI，果然很流畅，基本看不出和原生App的差距";
			if (~share.id.indexOf('weibo')) {
				msg.content += "；体验地址："+share_href;
			}
			msg.thumbs = [icon_src||(imgPath+"180x180.png")];
			share.send(msg, function() {
				console.log("分享到\"" + share.description + "\"成功！ ");
			}, function(e) {
				console.log("分享到\"" + share.description + "\"失败: " + e.code + " - " + e.message);
			});
		}
	}
})()
